# Sequencing

Understanding the complexity of an organism often starts with unravelling the order of the nucleotides from a DNA sample. It is important to know that a single DNA sample can contain the DNA from millions of hopefully near identical cells. One of the first widely adopted sequencing technologies was invented by Sanger (1975) and is therefore called Sanger sequencing. It uses a dideoxynucleotide_chain termination stopping the process when such a nucleotide is attached. It was a relatively efficient approach and reduced the radio activity but was very time consuming. 

Second and Third-generation sequencing technologies are currently the most widely implemented.  Illumina (second generation) can generate millions of relatively short reads at a very high speed whereas PacBio (third generation) on the other hand can generate fewer but relatively long reads. Each technique has its pros and cons and the complexity of an organism has to be taken into account when a high-quality dataset is to be obtained. Fourth generation sequencing is slowly becoming available of which the Oxford Nanopore is the most interesting as it can generate extremely long reads and can fit inside your pocket. 

**Course material:**

* Brock edition 14. Chapter 6.1, 6.2
* Brock edition 15. Chapter 9.1, 9.2
* Lecture on Sequencing


**Key questions:**

1. What would be an approach on sequencing an organism with many repeated regions in the genome?
2. Describe the principles of Sanger sequencing
3. What is shotgun sequencing?


# Assembly

Regardless what sequencing technique (2nd, 3rd, 4th generation) is used to retrieve the reads… The reads still need to be combined / assembled before it can be annotated and studied. All the reads generated by a sequencing machine are in a single format called FASTQ. FASTQ is a plain text format consisting of a header, a sequence, a + symbol and the quality corresponding to the certainty a nucleotide is most likely correct. Various applications exist to merge the reads into longer reads or so called contigs. These contigs can sometimes be merged into what they call scaffolds that eventually make up the whole chromosome or plasmid. 

There are dozens if not more different assemblers that can make an attempt to put the reads together. Some applications are specifically written for a certain sequencing technique while others allow to combine the results of different sequencers and perform a combinatorial approach in an attempt to obtain the whole genome. An incomplete representation of a genome is usually obtained, as finalizing all the last pieces into whole chromosomes is a manual and time-consuming approach which often requires the usage of different and multiple expensive sequence runs. However, a draft genome almost always contains more than enough information that is required for understanding the organism.

**Course material:**

* Practical Bioinformatics 2012. Page 10-12
* Lecture on assembly

**Key questions:**

1. How much read coverage is sufficient for a given genome?
2. What is the major cause of multiple contigs when performing an assembly?
3. What is a kmer size and how can this influence the assembly? 

## Practical: Sequencing and Assembly

Sequence assembly is the aligning and merging of small DNA fragments into a longer DNA sequences with the aim to reconstruct the original (genome) sequence. DNA sequencing of whole genomes cannot be done in one go. Current established technologies can only sequence 100-300 nt (Illumina)  600-800 nt (Sanger) or up-to 40.000 nt (PacBio) so the trick is to merge sequence reads using overlapping sequences.

###Concepts: Important terms to understand beforehand
* **Shotgun sequencing:** The technology used to sequence complete genomes. Shotgun sequencing involves randomly breaking up or shredding a (genomic or large) DNA sequence into many small fragments (hence shotgun), sequence them and then use a computer to reassemble the original sequence by finding regions of overlap.
* **Sequence read:** The result of the sequencing process and  read refers to a string of nucleotides. This string is presented in Fasta or Fastq format.
* **Contig:** When two or more sequence reads show a region of overlap, the can be merged into one single larger string. This merging by using overlap is the assembly process and the resulting string is called a contig and usually presented in fasta format. 
* **N50:** N50 is a statistics that defines the quality of an assembly. An assembly is a set of contigs that together represent a genome. Given a set of contigs, each with its own sequence length, N50 is defined as the shortest sequence length at 50% of the genome. A simple example of the calculation is found at https://en.wikipedia.org/wiki/N50,_L50,_and_related_statistics
* **Coverage:** This is a container term for a number of similar terms. Given a file with many sequence reads the average coverage be calculated from the length of the genome (G), the number of reads in the file  (N), and the average read length (L) of the reads in the file as N × L / G. In shotgun sequencing a high coverage is essential in order to find overlap between reads and repress sequence read errors as a result of the sequencing process which relates to the actual coverage at a particular position in a sequence
* **Assembler:** The computational tool to do the actual assembly. Many exist and they all have their benefits. Here we will use SPAdes (for St. Petersburg genome assembler) Spades is a genome assembly algorithm designed for single cell and multi-cells bacterial data sets. see Bankevich A. et al., SPAdes: A New Genome Assembly Algorithm and Its Applications to Single-Cell Sequencing SPAdes accepts as input file paired-end, mate-pairs and single Illumina, and Oxford Nanopore, PacBio, Ion Torrent sequence reads.

![Assembly](../../Figures/Assembly.png)
*Figure: Read mapping and contig calculations*

In the exercise, we will do a number of small assemblies. Before we start doing this we want you to answer a number of questions.

## Hands-on


> All data is normally accessible via Shared Data / Data Libraries but due to a permission issue you should be able to see them in the Shared history at https://galaxy.anunna.wur.nl/histories/list_published


![](../../Figures/published_histories.png)

### Formats

**Q1:** Fasta format: In your own words. What is Fasta format? Can you describe the format?

**Q2:** What is the difference between Fasta and Fastq format? Can you describe the Fastq format and point out the differences between Fasta and Fastq

### Coverage 
You will need to obtain these files from the galaxy ([https://galaxy.anunna.wur.nl](https://galaxy.anunna.wur.nl)]) ***Shared data*** section under ***Data libraries/WUR/AFSG/iBioSystems/Sequencing & Assembly***. These files contain sequence reads in Fastq format for 6x and 50x coverage for assembly of a 60 kb. 

Import the files into your history at Galaxy

**Q3:** How many lines do the file(s) have? **TIP**: You can use the tool in Galaxy (on left side in the browser)“Line/Word/Character count”

**Q4:** How many reads are in the file(s)? **(Remember how many lines 1 fastq has)**

**Q5:** What is the read length? **(Click on the eye icon to view the first part of a file)**

**Q6:** How many bases are therefore sequenced?

**Q7:** How many contigs are to be expected for the 6x coverage and 60kb genome size?

**Q8:** How many contigs are to be expected for the 50x coverage and 60kb genome size?

*References*

1.	Lander ES, Waterman MS.(1988) Genomic mapping by fingerprinting random clones: a mathematical analysis, Genomics 2(3): 231-239 Estimating the number of times a base is expected to be sequenced. 
**Note -** Lander and Waterman made two assumptions about the sequencing: 1) Reads will be distributed randomly across the genome. 2) Overlap detection doesn’t vary between reads. Based upon these two assumptions, they reached the conclusion that the number of times a base is sequenced follows a Poisson distribution. 


## Assembly

Running genome assemblies using your raw sequence data files.

The assembly will be performed using the Program <b>"SPAdes"</b> available on the left side

![](../../Figures/assembly_1.png)

There are many options for SPAdes but most of them are fine by default for this case. 

**Next step is choosing the correct input files (library)**

We have a set of Paired End reads, consisting of a Forward and Reverse read file.

(forward-read: R1 and reverse: R2)

![](../../Figures/assembly_2.png)

Scroll down and press **Execute** to start assembling.

-----

For the Assembly 6x coverage results answer the following questions:

**Q9:**  How many contigs do you have?

**Q10:** Is this according to your expectation? (explain)

**Q11:** N50 is metric for the quality of an assembly - What does the term N50 mean?

**Q12:** What is the N50 of the 6x coverage assembly?

Now do the 50x coverage assembly
For the Assembly 50x coverage results answer the following questions:

**Q13:** How many contigs do you have?

**Q14:** Is this according to your expectation? (explain)

**Q15:** What is the N50 of the 50x coverage assembly?

**Q16:** How many bases were assembled?

**Q17:** What is the real coverage?

Compare both assemblies with QUAST. 

<!--
Follow the instructions: 
[http://ssb1.wurnet.nl/bit/#quast-analysis](http://ssb1.wurnet.nl/bit/#quast-analysis)
-->

**Q18:** Why are we not so much interested in contigs shorter than 500bp when attempting to uncover the genetic basis of this genome?


##Strain analysis
Above, you have assembled a small 60 kb contig using the SPADES assembler. The process of assembling a real bacterial genome is exactly the same. The only differences is that it requires more computational power and therefore takes longer from a few mintutes to multiple days if not weeks! The strain that you have been working with in the lab has therefore already been assembled for you using the default settings used before.

**To obtain your data, in galaxy click on Shared Data > Data Libraries > WUR/AFSG/IBioData > Genomes / Reads** 

There you can download the `<yournumber>_1.fq` and `<yournumber>_2.fq` files by selecting the white box in front. After selection click on the `to History button`.

**We assembled your genome using Illumina paired–end reads so do not run SPADES on this data set as it will consume quite some resources and will cost a considerable amount of time**

**Q19:** What are read-pairs? What additional information can be extracted from a read-pair?

**Q20:** What is the expected coverage? **Note we are using read pairs here!** 

**Q21:** How many contigs do you expect? 

<!--Is this in expectation with the number of contigs obtained in the given Fasta file?-->

**Q22:** We have selected a single contig in Fasta format. What could this Fasta header mean?

    >NODE_2755_length_94_cov_1.41176

**To obtain the assembled genome click on Shared Data > Data Libraries** and in the right folder select `<yournumber>.fasta` file. After selection click on the `to History button`.

**Q23:** Use the `Select lines that match an expression` function in Galaxy to extract all the lines matching a `>`.
You will end up with a new file only containing the fasta headers. Load the file in excel and split into columns using the `_` variable. 

**Q24:** How many contigs do you have? Is this what you expected?

**Q24:** What is the lowest coverage?

**Q25:** What is the average coverage and is this in line with the expected coverage?

**Q26:** What is the maximum coverage observed?

**Q27:** What could be the reasons why the maximum coverage is significantly higher than the average or expected coverage?

**Q28:** What is the smallest and the largest contig?

**Q29:** Would you keep or remove small contigs (e.g. <200bp)?

**Q30:** Does it have an impact, removing these small contigs, on N50, overall coverage, genome size, GC content, ...?

### QUAST
Many tools exist to calculate and analyse the genome assembly results. One of these tools is called Quast and can be found in the Galaxy toolbox on the left. Under **Contigs/scaffolds output file** select your genome fasta file and click **execute**. The result file contains a nice summary of the total size, largest contig, N50 etc which can be helpful for your report in the end. 

**Do not forget to update your labjournal with all the findings you have!**


```{note}
Last but not least, you can automate processes by the development of Galaxy Workflows. If you have time feel free to check out the next section "Galaxy Workflows".
```
